:: checksum portable creation processor, by seVen   v0.2
:: minor edits and tweaks by (or
::
:: a checksum extra
::
:: This is a simple Windows command (batch) file that can be
:: used to access checksum's creation features when running 
:: in portable mode, from a pen-drive, or whatever. Simply drop
:: it next to checksum.exe and drop stuff on it. Multiple files 
:: and folders will be processed in a queue.
::
:: See the accompanying nfo file for usage and customization 
:: information. More information about checksum, here..
::
::	http://corz.org/windows/software/checksum/
::

@ECHO OFF
SET relpath="%~dp0checksum.exe"
IF NOT EXIST %relpath% GOTO ERROR2
SET fldrs=0
SET fls=0
SET counter=0
FOR %%F IN (%*) DO IF EXIST "%%~F\*" (SET fldrs=1 && SET /a counter+=1) ELSE IF /i NOT %%~xF==.md5 (SET fls=1 && SET /a counter+=1)
IF %counter%==0 GOTO ERROR1
ECHO.
ECHO.
ECHO ::::::
ECHO :::
ECHO :::
IF %counter%==1 (ECHO ::: The following item will be processed by checksum:) ELSE (ECHO ::: A total of %counter% jobs have been added to the queue:)
ECHO :::
ECHO :::
FOR %%F IN (%*) DO IF EXIST "%%~F\*" (ECHO ::: %%~F\) ELSE IF /i NOT %%~xF==.md5 (ECHO ::: %%~F)
ECHO :::
ECHO :::
ECHO ::::::
ECHO :::
ECHO ::: NOTE: 
ECHO :::
IF %fldrs%==1 ECHO ::: * checksum will create a separate MD5 file
IF %fldrs%==1 ECHO :::   for the contents of each folder listed above
IF %fldrs%==1 ECHO :::   including their subfolders.
IF %fldrs%==1 ECHO :::
IF %fls%==1 ECHO ::: * checksum will create a separate MD5 file
IF %fls%==1 ECHO :::   for each file listed above.
IF %fls%==1 ECHO :::
ECHO ::::::
ECHO.
ECHO.
SET /p qmode=::: If MD5 already exists: (i)gnore, (o)verwrite, (s)ync:
IF /i %qmode%==i SET switch=q&& GOTO BEGIN
IF /i %qmode%==o SET switch=q+&& GOTO BEGIN
IF /i %qmode%==s SET switch=qy&& GOTO BEGIN
GOTO END

:BEGIN
ECHO.
ECHO.
ECHO :::
ECHO :::
ECHO ::: checksum creation in progress...
ECHO :::
ECHO :::
::
::	if you want to add switches, disable audio alerts, or whatever..
::                                  see here ----V----                                          and here ---V---
FOR %%F IN (%*) DO IF EXIST "%%~F\*" (%relpath% cnr%switch% "%%~F\") ELSE IF /i NOT %%~xF==.md5 (%relpath% cin%switch% "%%~F")
GOTO END

:ERROR1
ECHO.
ECHO ::::::: ERROR: VALID INPUTS NOT FOUND :::::::
ECHO ::                                         ::
ECHO ::                                         ::
ECHO :: You are seeing this message because you ::
ECHO :: haven't specified ANY valid inputs.     ::
ECHO ::                                         ::
ECHO :: You must have at least one valid input  ::
ECHO :: for this script to function properly.   ::
ECHO ::                                         ::
ECHO ::                                         ::
ECHO ::    Valid Inputs...... Files/Folders     ::
ECHO ::    Invalid Inputs.... MD5 Files         ::
ECHO ::                                         ::
ECHO ::                                         ::
ECHO :::::::::::::::::::::::::::::::::::::::::::::
ECHO.
ECHO.
ECHO ::: Press any key to quit . . .
PAUSE > NUL
GOTO END

:ERROR2
ECHO.
ECHO ::::::::: CHECKSUM.EXE NOT FOUND :::::::::
ECHO ::                                      ::
ECHO :: This batch script must be located in ::
ECHO :: the same directory as checksum.exe   ::
ECHO ::                                      ::
ECHO ::::::::::::::::::::::::::::::::::::::::::
ECHO.
ECHO.
ECHO ::: Press any key to quit . . .
PAUSE > NUL
GOTO END

:END
EXIT